﻿Public Class CPM_S500


    Private Declare Function openMonitor Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function closeMonitor Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function getSerial Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal szSN As String, ByVal iSize As Integer) As Integer
    Private Declare Function getPower Lib "S500API_NEO.dll" (ByVal szPort As String) As Double
    Private Declare Function isOpen Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function flush Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function setWavelength Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal iWaveLen As Integer) As Integer
    Private Declare Function getWavelength Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function getChannel Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function getSampleRate Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function setSampleRate Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal chRate As Char) As Integer
    Private Declare Function getMode Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function setMode Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal chMode As Char) As Integer
    Private Declare Function getPolarization Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function setPolarization Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal iPol As Integer) As Integer
    Private Declare Function getBatteryPower Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer
    Private Declare Function setLicenseFilePath Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal szPath As String) As Integer
    Private Declare Function getModel Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal szModel As String, ByVal iSize As Integer) As Integer
    Private Declare Function getRevInfo Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal szRevInfo As String, ByVal iSize As Integer) As Integer
    Private Declare Function getLastError Lib "S500API_NEO.dll" (ByVal szPort As String, ByVal szErrorInfo As String, ByVal iSize As Integer) As Integer
    Private Declare Function isLicensed Lib "S500API_NEO.dll" (ByVal szPort As String) As Integer

    Private m_csPort As String
    Public Sub New(ByVal strPort As String)
        m_csPort = strPort
        Open()
    End Sub
    Public Function Open() As Boolean
        Dim iRet As Integer
        iRet = openMonitor(m_csPort)

        If iRet = 1 Then
            Return True
        Else
            Return False
        End If


    End Function
    Public Function Close() As Boolean
        closeMonitor(m_csPort)
        Return True
    End Function

    Public Function setWavelen(ByVal iniWaveLeng As Integer) As Boolean
        Dim iRet As Integer

        Dim strData As String
        strData = New String(Chr(0), 255)

        iRet = setWavelength(m_csPort, iniWaveLeng)

        Return iRet
    End Function

    Public Function GetWavelen() As Integer
        Dim iRet As Integer
        Dim bRet As Boolean = True
        iRet = getWavelength(m_csPort)
        Return iRet
    End Function
    Public Function GetSN(ByRef strSN) As Boolean
        Dim iRet As Integer

        Dim strData As String
        strData = New String(Chr(0), 255)

        iRet = getSerial(m_csPort, strData, 255)

        strSN = Left(strData, iRet)
        Return True
    End Function
    Public Function GetPow(ByRef dPower As Double) As Boolean
        Dim dTmp As Double
        dTmp = getPower(m_csPort)
        If dTmp > 99 Then
            dPower = -100
            Return False
        End If
        dPower = dTmp
        Return True
    End Function
    Public Sub SetLicenseFilePath(ByVal strPath As String)
        Dim iRet As Integer
        iRet = setLicenseFilePath(m_csPort, strPath)
    End Sub
    Public Function GetModelNum(ByRef strModel As String) As Boolean


        Dim iRet As Integer

        Dim strData As String
        strData = New String(Chr(0), 255)

        iRet = getModel(m_csPort, strData, 255)

        strModel = Left(strData, iRet)
        Return True
    End Function

    Public Function GetRevInfor(ByRef strRev As String) As Boolean


        Dim iRet As Integer

        Dim strData As String
        strData = New String(Chr(0), 255)

        iRet = getRevInfo(m_csPort, strData, 255)

        strRev = Left(strData, iRet)
        Return True
    End Function
    Public Function GetLastError(ByRef strError As String) As Boolean


        Dim iRet As Integer

        Dim strData As String
        strData = New String(Chr(0), 255)

        iRet = GetLastError(m_csPort, strData, 255)

        strError = Left(strData, iRet)
        Return True
    End Function
    Public Function IsLicensed() As Boolean
        Dim iRet As Integer
        iRet = IsLicensed(m_csPort)
        If iRet = 1 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
