﻿'Imports System.Runtime.InteropServices
Imports System.IO
Public Class FrmMain
    Public Delegate Sub TestStartRun()
    Private callBack As Threading.WaitCallback

    Dim ArrPMLst As New ArrayList

    Private Sub FrmMain_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        g_RunPM = False
    End Sub

    Private Sub FrmMain_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        'g_LicenseFilePath = "D:\NeoLicense"
        g_LicenseFilePath = My.Application.Info.DirectoryPath & "\NeoLicense"
        g_LogFile = ""

        SetDataViewHead()
        Dim bRet As Boolean = iniLoad()
    End Sub

    Private Sub ButOpen_Click(sender As System.Object, e As System.EventArgs) Handles ButOpen.Click
        Dim strTitle As String = ButOpen.Text
        If strTitle = "Stop" Then
            ButOpen.Text = "Start"
            g_RunPM = False
            PictureBox2.Image = My.Resources.icon1
        Else
            ButOpen.Text = "Stop"
            g_RunPM = True
            callBack = New Threading.WaitCallback(AddressOf RunTest)
            Threading.ThreadPool.QueueUserWorkItem(callBack, Nothing)
            PictureBox2.Image = My.Resources.icon2
        End If
    End Sub
    Private Function iniLoad() As Boolean
        Dim bRet As Boolean = True
        Dim arrCom() As String = Nothing
        Dim sSN As String
        Dim nCount As Integer = 0
        Dim strNoLicense As String = ""
        Dim CurrCBBox As ComboBox
        CommSerial(arrCom)
        If IsNothing(arrCom) = False Then
            SplashScreen1.Show()
            For i As Integer = 0 To arrCom.GetUpperBound(0)
                SplashScreen1.ApplicationTitle.Text = "Scanning S500 devices, please wait..."
                Application.DoEvents()
                sSN = GetPMSN(arrCom(i))
                If sSN <> "" Then
                    Dim stItem As stPowerMonitor
                    With stItem
                        .PMObj = New CPM_S500(arrCom(i))
                        .sCom = arrCom(i)
                        .sSerialNo = sSN
                        .PMObj.setLicenseFilePath(g_LicenseFilePath)
                        .isLicense = .PMObj.IsLicensed
                        .isUse = False
                        If .isLicense = False Then
                            strNoLicense += sSN
                        Else
                            nCount += 1
                            .nTag = nCount
                            ArrPMLst.Add(stItem)
                            CurrCBBox = GetCurrentCombox(nCount, 0)
                            If IsNothing(CurrCBBox) = False Then
                                CurrCBBox.Items.Add("")
                                CurrCBBox.Items.Add(sSN)
                            End If
                        End If
                        SetViewSNLicense(sSN, .isLicense)
                    End With


                End If
            Next
           
        End If
        bRet = AddControlEvent()
        SplashScreen1.Close()
        Return bRet
    End Function
    Private Sub SetDataViewHead()
        Dim arrColumn() As String = {"Serial Number", "Status"}
        With ViewSet
            .Refresh()
            .ColumnHeadersVisible = True
            .RowHeadersVisible = False
            .EditMode = DataGridViewEditMode.EditOnEnter
        End With

        For i As Integer = 0 To UBound(arrColumn)
            Dim Coltype As New DataGridViewTextBoxColumn
            With Coltype
                .HeaderText = arrColumn(i)
                '  .Name = sName
                .SortMode = DataGridViewColumnSortMode.NotSortable '不可排序
                .Width = 150
                .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft  '对齐
                ViewSet.Columns.Add(Coltype)
                '.HeaderText = "Licensed Valid"
                'ViewSet.Columns.Add(Coltype)
            End With
        Next
        '   ViewSet.Rows.Clear()
        Return
    End Sub
    Private Sub SetViewSNLicense(ByVal sSn As String, ByVal bLic As Boolean)
        Dim nRowCnt As Integer
        Dim iCol, iRow As Integer
        Dim tempRow As New DataGridViewRow
        Dim SetColor As System.Drawing.Color
        Dim sValidLic As String
        ' tempRow.Height = 18 '设置行高
        tempRow.ReadOnly = True
        ViewSet.Rows.Add(tempRow)
        iRow = ViewSet.RowCount
        iCol = 0
        ViewSet.Item(0, iRow - 1).Value = sSn.ToString
        iCol = 1
        If bLic Then
            sValidLic = "Licensed"
            SetColor = Color.Green
        Else
            sValidLic = "Not Licensed"
            SetColor = Color.Red
        End If
        ViewSet.Item(1, iRow - 1).Value = sValidLic
        ViewSet.Item(1, iRow - 1).Style.BackColor = SetColor

        ViewSet.Refresh()
    End Sub
    Private Function AddControlEvent() As Boolean
        Dim k As Integer
        Dim CurrSNCtl, CurrWLCtl As ComboBox
        Dim bRet As Boolean = True
        Try
            For k = 1 To 24
                CurrSNCtl = GetCurrentCombox(k, 0)
                If IsNothing(CurrSNCtl) = False Then
                    AddHandler CurrSNCtl.SelectedIndexChanged, AddressOf CbSN1_Click
                End If

                CurrWLCtl = GetCurrentCombox(k, 1)
                If IsNothing(CurrWLCtl) = False Then
                    AddHandler CurrWLCtl.SelectedIndexChanged, AddressOf CbWL_Click
                End If
            Next
            PictureBox2.Image = My.Resources.icon2
            g_RunPM = True
            callBack = New Threading.WaitCallback(AddressOf RunTest)
            Threading.ThreadPool.QueueUserWorkItem(callBack, Nothing)
        Catch ex As Exception
            bRet = False
        End Try
        Return bRet
    End Function
    Private Sub RunTest()

        Dim delTestDataWork As New TestStartRun(AddressOf RunTestStart)
        Try
            If Me.InvokeRequired Then
                Me.Invoke(delTestDataWork, Nothing)
            End If
        Catch ex As Exception

        End Try
       
    End Sub
    Private Sub RunTestStart()
        Dim k, iTag As Integer
        Dim CurrCtl As TextBox
        Dim fReadPo As Single
        Dim CurrPM As stPowerMonitor
        Dim bRet As Boolean
        While (g_RunPM)
            For k = 0 To ArrPMLst.Count - 1
                If CType(ArrPMLst.Item(k), stPowerMonitor).isUse Then
                    CurrPM = ArrPMLst.Item(k)
                    iTag = CurrPM.nTag
                    bRet = CurrPM.PMObj.GetPow(fReadPo)
                    CurrCtl = GetCurrentCombox(iTag, 2)
                    CurrCtl.Text = FormatNumber(fReadPo, 2)
                    If CkLog.CheckState = CheckState.Checked Then
                        bRet = SaveLogFile(CurrPM.sSerialNo, FormatNumber(fReadPo, 2), CurrPM.sWaveLen)
                    End If
                End If
            Next
            'TextBox2.Text = Now
            Application.DoEvents()
            Threading.Thread.Sleep(1000)
            Application.DoEvents()
        End While
    End Sub
    Private Function SaveLogFile(ByVal sSN As String, ByVal fPo As Single, ByVal nWaveLeng As String) As Boolean
        Dim bRet As Boolean = True
        'Dim fn As IO.FileStream
        Dim sw As StreamWriter = Nothing
        Dim strMsg As String
        Dim sTitle As String = "DATE REC    TIME REC	SERIAL NO	P (dBm)	WAVE"
        Dim currTime As Date = Date.Now
        Try
            If g_LogFile = "" Then Return bRet
            If File.Exists(g_LogFile) = False Then
                sw = File.CreateText(g_LogFile)
                sw.WriteLine(sTitle)
            Else

                sw = File.AppendText(g_LogFile)
            End If
            strMsg = currTime.ToString("yyyy-MM-dd") & "  " & currTime.ToString("HH:mm:ss") & "    " & sSN & "       " & fPo & "   " & nWaveLeng
            sw.WriteLine(strMsg)

        Catch ex As Exception
            bRet = False
        Finally
            If (sw IsNot Nothing) Then
                sw.Close()
            End If

        End Try
        Return bRet
    End Function
    Private Sub CbSN1_Click(sender As Object, e As System.EventArgs)
        Dim iTag As Integer = Val(sender.tag)
        Dim CurrCtl As ComboBox
        Dim nIdxPm As Integer
        Dim strSN As String
        Dim arrWaveLen() As String = {"1310", "1480", "1550"}
        Dim subItem As stPowerMonitor = Nothing
        strSN = CType(sender, ComboBox).Text
        CurrCtl = GetCurrentCombox(iTag, 1)
        nIdxPm = SearchPmLst(iTag)
        If nIdxPm >= 0 Then
            subItem = ArrPMLst.Item(nIdxPm)
        End If
        If strSN = "" Then
            CurrCtl.Items.Clear()
            subItem.isUse = False
            ArrPMLst.RemoveAt(nIdxPm)
            ArrPMLst.Add(subItem)
            Return
        End If
        'nIdxPm = SearchPmLst(iTag)
        If nIdxPm < 0 Then Return


        If CurrCtl.Items.Count = 0 Then
            For i As Integer = 0 To UBound(arrWaveLen)
                CurrCtl.Items.Add(arrWaveLen(i))
            Next
        End If

        CurrCtl.Text = subItem.PMObj.GetWavelen
        'ArrPMLst.Item(nIdxPm).isUse = True
        subItem.isUse = True
        subItem.sWaveLen = CurrCtl.Text
        ArrPMLst.RemoveAt(nIdxPm)
        ArrPMLst.Add(subItem)
    End Sub

    Private Sub CbWL_Click(sender As Object, e As System.EventArgs)
        Dim iTag As Integer = Val(sender.tag)
        Dim nIdxPm As Integer
        Dim strWL, intWL As String
        Dim subItem As stPowerMonitor
        Dim bRet As Boolean
        strWL = CType(sender, ComboBox).Text

        nIdxPm = SearchPmLst(iTag)
        If nIdxPm >= 0 Then
            subItem = ArrPMLst.Item(nIdxPm)
            intWL = subItem.PMObj.GetWavelen
            If intWL <> strWL Then
                bRet = subItem.PMObj.setWavelen(CInt(strWL))
                subItem.sWaveLen = strWL
                ArrPMLst.RemoveAt(nIdxPm)
                ArrPMLst.Add(subItem)
            End If

        End If

    End Sub
    Private Function SearchPmLst(ByVal iTag As Integer) As Integer
        Dim nIndex As Integer = -1
        For i As Integer = 0 To ArrPMLst.Count - 1
            If CType(ArrPMLst.Item(i), stPowerMonitor).nTag = iTag Then
                nIndex = i
                Exit For
            End If
        Next
        Return nIndex
    End Function
    Private Function GetCurrentCombox(ByVal nTag As Integer, nType As Integer) As Object
        Dim CurrCtl As Object = Nothing
        If nType = 1 Then
            Select Case nTag
                Case 1
                    CurrCtl = CbWL1
                Case 2
                    CurrCtl = CbWL2
                Case 3
                    CurrCtl = CbWL3
                Case 4
                    CurrCtl = CbWL4
                Case 5
                    CurrCtl = CbWL5
                Case 6
                    CurrCtl = CbWL6
                Case 7
                    CurrCtl = CbWL7
                Case 8
                    CurrCtl = CbWL8
                Case 9
                    CurrCtl = CbWL9
                Case 10
                    CurrCtl = CbWL10
                Case 11
                    CurrCtl = CbWL11
                Case 12
                    CurrCtl = CbWL12
                Case 13
                    CurrCtl = CbWL13
                Case 14
                    CurrCtl = CbWL14
                Case 15
                    CurrCtl = CbWL15
                Case 16
                    CurrCtl = CbWL16
                Case 17
                    CurrCtl = CbWL17
                Case 18
                    CurrCtl = CbWL18
                Case 19
                    CurrCtl = CbWL19
                Case 20
                    CurrCtl = CbWL20
                Case 21
                    CurrCtl = CbWL21
                Case 22
                    CurrCtl = CbWL22
                Case 23
                    CurrCtl = CbWL23
                Case 24
                    CurrCtl = CbWL24

            End Select
        ElseIf nType = 2 Then
            Select Case nTag
                Case 1
                    CurrCtl = TxtPo1
                Case 2
                    CurrCtl = TxtPo2
                Case 3
                    CurrCtl = TxtPo3
                Case 4
                    CurrCtl = TxtPo4
                Case 5
                    CurrCtl = TxtPo5
                Case 6
                    CurrCtl = TxtPo6
                Case 7
                    CurrCtl = TxtPo7
                Case 8
                    CurrCtl = TxtPo8
                Case 9
                    CurrCtl = TxtPo9
                Case 10
                    CurrCtl = TxtPo10
                Case 11
                    CurrCtl = TxtPo11
                Case 12
                    CurrCtl = TxtPo12
                Case 13
                    CurrCtl = TxtPo13
                Case 14
                    CurrCtl = TxtPo14
                Case 15
                    CurrCtl = TxtPo15
                Case 16
                    CurrCtl = TxtPo16
                Case 17
                    CurrCtl = TxtPo17
                Case 18
                    CurrCtl = TxtPo18
                Case 19
                    CurrCtl = TxtPo19
                Case 20
                    CurrCtl = TxtPo20
                Case 21
                    CurrCtl = TxtPo21
                Case 22
                    CurrCtl = TxtPo22
                Case 23
                    CurrCtl = TxtPo23
                Case 24
                    CurrCtl = TxtPo24

            End Select
        Else
            Select Case nTag
                Case 1
                    CurrCtl = CbSN1
                Case 2
                    CurrCtl = CbSN2
                Case 3
                    CurrCtl = CbSN3
                Case 4
                    CurrCtl = CbSN4
                Case 5
                    CurrCtl = CbSN5
                Case 6
                    CurrCtl = CbSN6
                Case 7
                    CurrCtl = CbSN7
                Case 8
                    CurrCtl = CbSN8
                Case 9
                    CurrCtl = CbSN9
                Case 10
                    CurrCtl = CbSN10
                Case 11
                    CurrCtl = CbSN11
                Case 12
                    CurrCtl = CbSN12
                Case 13
                    CurrCtl = CbSN13
                Case 14
                    CurrCtl = CbSN14
                Case 15
                    CurrCtl = CbSN15
                Case 16
                    CurrCtl = CbSN16
                Case 17
                    CurrCtl = CbSN17
                Case 18
                    CurrCtl = CbSN18
                Case 19
                    CurrCtl = CbSN19
                Case 20
                    CurrCtl = CbSN20
                Case 21
                    CurrCtl = CbSN21
                Case 22
                    CurrCtl = CbSN22
                Case 23
                    CurrCtl = CbSN23
                Case 24
                    CurrCtl = CbSN24

            End Select
        End If
        Return CurrCtl
    End Function

    Private Sub ButFile_Click(sender As System.Object, e As System.EventArgs) Handles ButFile.Click
        Dim sFile As String
        With SaveFileDialog1
            .Title = "Save log,LOG"
            .FileName = ""
            '.CancelError = False
            .Filter = "Log Files (*.Log)|*.Log|所有文件(*.*) |*.*"
            '        .Flags = &H200
            .FilterIndex = 1
            .ShowDialog()
            If Len(.FileName) = 0 Then
                Exit Sub
            End If
            sFile = .FileName

        End With
        TextBox1.Text = sFile
        g_LogFile = sFile
    End Sub

    Private Sub CkLog_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CkLog.CheckedChanged
        Dim sFile As String
        If CkLog.CheckState = CheckState.Checked And Trim(TextBox1.Text) = "" Then

            With SaveFileDialog1
                .Title = "Save log,LOG"
                .FileName = ""
                '.CancelError = False
                .Filter = "Log Files (*.Log)|*.Log|所有文件(*.*) |*.*"
                '        .Flags = &H200
                .FilterIndex = 1
                .ShowDialog()
                If Len(.FileName) = 0 Then
                    Exit Sub
                End If
                sFile = .FileName

            End With
            TextBox1.Text = sFile
            g_LogFile = sFile
        End If
    End Sub

  
   
End Class
